1*7c478bd9Sstevel@tonic-gate#
2*7c478bd9Sstevel@tonic-gate# Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
3*7c478bd9Sstevel@tonic-gate# Use is subject to license terms.
4*7c478bd9Sstevel@tonic-gate#
5*7c478bd9Sstevel@tonic-gate# CDDL HEADER START
6*7c478bd9Sstevel@tonic-gate#
7*7c478bd9Sstevel@tonic-gate# The contents of this file are subject to the terms of the
8*7c478bd9Sstevel@tonic-gate# Common Development and Distribution License, Version 1.0 only
9*7c478bd9Sstevel@tonic-gate# (the "License").  You may not use this file except in compliance
10*7c478bd9Sstevel@tonic-gate# with the License.
11*7c478bd9Sstevel@tonic-gate#
12*7c478bd9Sstevel@tonic-gate# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
13*7c478bd9Sstevel@tonic-gate# or http://www.opensolaris.org/os/licensing.
14*7c478bd9Sstevel@tonic-gate# See the License for the specific language governing permissions
15*7c478bd9Sstevel@tonic-gate# and limitations under the License.
16*7c478bd9Sstevel@tonic-gate#
17*7c478bd9Sstevel@tonic-gate# When distributing Covered Code, include this CDDL HEADER in each
18*7c478bd9Sstevel@tonic-gate# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
19*7c478bd9Sstevel@tonic-gate# If applicable, add the following below this CDDL HEADER, with the
20*7c478bd9Sstevel@tonic-gate# fields enclosed by brackets "[]" replaced with your own identifying
21*7c478bd9Sstevel@tonic-gate# information: Portions Copyright [yyyy] [name of copyright owner]
22*7c478bd9Sstevel@tonic-gate#
23*7c478bd9Sstevel@tonic-gate# CDDL HEADER END
24*7c478bd9Sstevel@tonic-gate#
25*7c478bd9Sstevel@tonic-gate# ident	"%Z%%M%	%I%	%E% SMI"
26*7c478bd9Sstevel@tonic-gate#
27*7c478bd9Sstevel@tonic-gate# Class action script for "kcfconf" class files.
28*7c478bd9Sstevel@tonic-gate#
29*7c478bd9Sstevel@tonic-gate# This script appends the input file from the package to the
30*7c478bd9Sstevel@tonic-gate# /etc/crypto/kcf.conf file.
31*7c478bd9Sstevel@tonic-gate#
32*7c478bd9Sstevel@tonic-gate# The syntax of the input file for a kernel software provider package is
33*7c478bd9Sstevel@tonic-gate# <provider_name>:supportedlist=<mechlist>
34*7c478bd9Sstevel@tonic-gate#   where
35*7c478bd9Sstevel@tonic-gate#     <provider_name> ::= the kernel software module base name
36*7c478bd9Sstevel@tonic-gate#     <mechlist> ::= <mechanism>{,<mechanism>}*
37*7c478bd9Sstevel@tonic-gate#     <mechanism> ::= a mechanism name as specified by the RSA PKCS#11 spec.
38*7c478bd9Sstevel@tonic-gate#
39*7c478bd9Sstevel@tonic-gate# The syntax of the input file for a cryptographic provider device driver(s)
40*7c478bd9Sstevel@tonic-gate# package is
41*7c478bd9Sstevel@tonic-gate# driver_names=<driver_name_list>
42*7c478bd9Sstevel@tonic-gate#   where
43*7c478bd9Sstevel@tonic-gate#     <driver_name_list> ::= <name>{,<name>}*
44*7c478bd9Sstevel@tonic-gate#     <name> ::= a device driver name
45*7c478bd9Sstevel@tonic-gate#
46*7c478bd9Sstevel@tonic-gatepkg_start="# Start $PKGINST"
47*7c478bd9Sstevel@tonic-gatepkg_end="# End $PKGINST"
48*7c478bd9Sstevel@tonic-gatetmpfile=/tmp/$$kcfconf
49*7c478bd9Sstevel@tonic-gateerror=no
50*7c478bd9Sstevel@tonic-gate
51*7c478bd9Sstevel@tonic-gatewhile read src dest
52*7c478bd9Sstevel@tonic-gatedo
53*7c478bd9Sstevel@tonic-gate	[ "$src" = /dev/null ] && continue
54*7c478bd9Sstevel@tonic-gate
55*7c478bd9Sstevel@tonic-gate	if [ -f "$dest" ]
56*7c478bd9Sstevel@tonic-gate	then
57*7c478bd9Sstevel@tonic-gate		# For multiple input files; exit if error occurred in previous
58*7c478bd9Sstevel@tonic-gate		# input file.
59*7c478bd9Sstevel@tonic-gate		if [ "$error" = yes ]
60*7c478bd9Sstevel@tonic-gate		then
61*7c478bd9Sstevel@tonic-gate			echo "$0: failed to update $lastdest for $PKGINST."
62*7c478bd9Sstevel@tonic-gate			exit 2
63*7c478bd9Sstevel@tonic-gate		fi
64*7c478bd9Sstevel@tonic-gate		lastdest=$dest
65*7c478bd9Sstevel@tonic-gate
66*7c478bd9Sstevel@tonic-gate		#
67*7c478bd9Sstevel@tonic-gate		# If the package has been already installed, remove old entries
68*7c478bd9Sstevel@tonic-gate		#
69*7c478bd9Sstevel@tonic-gate		start=0;
70*7c478bd9Sstevel@tonic-gate		end=0;
71*7c478bd9Sstevel@tonic-gate		egrep -s "$pkg_start" $dest && start=1
72*7c478bd9Sstevel@tonic-gate		egrep -s "$pkg_end" $dest && end=1
73*7c478bd9Sstevel@tonic-gate
74*7c478bd9Sstevel@tonic-gate		if [ $start -ne $end ]
75*7c478bd9Sstevel@tonic-gate		then
76*7c478bd9Sstevel@tonic-gate			echo "$0: missing Start or End delimiters for \
77*7c478bd9Sstevel@tonic-gate			    $PKGINST in $dest."
78*7c478bd9Sstevel@tonic-gate			echo "$0: $dest may be corrupted and was not updated."
79*7c478bd9Sstevel@tonic-gate			error=yes
80*7c478bd9Sstevel@tonic-gate			continue
81*7c478bd9Sstevel@tonic-gate		fi
82*7c478bd9Sstevel@tonic-gate
83*7c478bd9Sstevel@tonic-gate		if [ $start -eq 1 ]
84*7c478bd9Sstevel@tonic-gate		then
85*7c478bd9Sstevel@tonic-gate			sed -e "/$pkg_start/,/$pkg_end/d" $dest > $tmpfile \
86*7c478bd9Sstevel@tonic-gate			|| error=yes
87*7c478bd9Sstevel@tonic-gate		else
88*7c478bd9Sstevel@tonic-gate			cp $dest $tmpfile || error=yes
89*7c478bd9Sstevel@tonic-gate		fi
90*7c478bd9Sstevel@tonic-gate
91*7c478bd9Sstevel@tonic-gate		#
92*7c478bd9Sstevel@tonic-gate		# Check the input file syntax and append the input entries
93*7c478bd9Sstevel@tonic-gate		# with the package delimiters.
94*7c478bd9Sstevel@tonic-gate		#
95*7c478bd9Sstevel@tonic-gate		line_count=`wc -l $src | awk '{ print $1}'`
96*7c478bd9Sstevel@tonic-gate
97*7c478bd9Sstevel@tonic-gate		grep "driver_names" $src > /dev/null
98*7c478bd9Sstevel@tonic-gate		if [ $? -eq 0 ]
99*7c478bd9Sstevel@tonic-gate		then
100*7c478bd9Sstevel@tonic-gate			#
101*7c478bd9Sstevel@tonic-gate			# This is a device driver package.
102*7c478bd9Sstevel@tonic-gate			# - $src should contain only one line.
103*7c478bd9Sstevel@tonic-gate			# - If syntax of $src is correct, append the package
104*7c478bd9Sstevel@tonic-gate			#   start delimiter with the driver_names string.
105*7c478bd9Sstevel@tonic-gate			#
106*7c478bd9Sstevel@tonic-gate			if [ $line_count -ne 1 ]; then
107*7c478bd9Sstevel@tonic-gate				echo "$0: Syntax Error - $src for $PKGINST."
108*7c478bd9Sstevel@tonic-gate				error=yes
109*7c478bd9Sstevel@tonic-gate				continue
110*7c478bd9Sstevel@tonic-gate			else
111*7c478bd9Sstevel@tonic-gate				echo "$pkg_start `cat $src`" >> $tmpfile \
112*7c478bd9Sstevel@tonic-gate				|| error=yes
113*7c478bd9Sstevel@tonic-gate			fi
114*7c478bd9Sstevel@tonic-gate		else
115*7c478bd9Sstevel@tonic-gate			#
116*7c478bd9Sstevel@tonic-gate			# This is a kernel software provider package.
117*7c478bd9Sstevel@tonic-gate			# - Each line in $src should contain "supportedlist".
118*7c478bd9Sstevel@tonic-gate			# - If syntax of $src is correct, append the package
119*7c478bd9Sstevel@tonic-gate			#   start delimiter and the $src file.
120*7c478bd9Sstevel@tonic-gate			#
121*7c478bd9Sstevel@tonic-gate			supported_count=`grep supportedlist $src |wc -l`
122*7c478bd9Sstevel@tonic-gate			if [ $line_count -ne $supported_count ]
123*7c478bd9Sstevel@tonic-gate			then
124*7c478bd9Sstevel@tonic-gate				echo "$0: Syntax Error - $src for $PKGINST."
125*7c478bd9Sstevel@tonic-gate				error=yes
126*7c478bd9Sstevel@tonic-gate				continue
127*7c478bd9Sstevel@tonic-gate			else
128*7c478bd9Sstevel@tonic-gate				echo "$pkg_start" >> $tmpfile || error=yes
129*7c478bd9Sstevel@tonic-gate				cat $src >> $tmpfile || error=yes
130*7c478bd9Sstevel@tonic-gate			fi
131*7c478bd9Sstevel@tonic-gate		fi
132*7c478bd9Sstevel@tonic-gate		echo "$pkg_end" >> $tmpfile || error=yes
133*7c478bd9Sstevel@tonic-gate
134*7c478bd9Sstevel@tonic-gate		# Install the updated config file and clean up the tmp file
135*7c478bd9Sstevel@tonic-gate                if [ "$error" = no ]
136*7c478bd9Sstevel@tonic-gate                then
137*7c478bd9Sstevel@tonic-gate			mv $tmpfile $dest || error=yes
138*7c478bd9Sstevel@tonic-gate		fi
139*7c478bd9Sstevel@tonic-gate		rm -f $tmpfile
140*7c478bd9Sstevel@tonic-gate	else
141*7c478bd9Sstevel@tonic-gate		echo "$0: ERROR - $dest doesn't exist for $PKGINST."
142*7c478bd9Sstevel@tonic-gate		exit 2
143*7c478bd9Sstevel@tonic-gate	fi
144*7c478bd9Sstevel@tonic-gatedone
145*7c478bd9Sstevel@tonic-gate
146*7c478bd9Sstevel@tonic-gateif [ "$error" = yes ]
147*7c478bd9Sstevel@tonic-gatethen
148*7c478bd9Sstevel@tonic-gate	echo "$0: ERROR - failed to update $lastdest for $PKGINST."
149*7c478bd9Sstevel@tonic-gate	exit 2
150*7c478bd9Sstevel@tonic-gatefi
151*7c478bd9Sstevel@tonic-gate
152*7c478bd9Sstevel@tonic-gateexit 0
153